#include "alcontactlistener.h"
#include "creature.h"

void ALContactListener::BeginContact(b2Contact* contact)
{
    b2Fixture *fixtureA = contact->GetFixtureA();
    Creature* creatureA = (Creature *) fixtureA->GetBody()->GetUserData();
    
    b2Fixture *fixtureB = contact->GetFixtureB();
    Creature* creatureB = (Creature *) fixtureB->GetBody()->GetUserData();
    
    if( creatureA && creatureB )
    {
	if( /*creatureA->type() != Creature::PLANT &&*/ // plants don't do anything to other creatures
	    !fixtureB->IsSensor()                    // and we can't see others' sight / sense others' sensors
	)
	{
	    if( fixtureA->IsSensor() )
	    {
		creatureA->addToNearBy( creatureB );
	    }
	    else
	    {
		creatureA->addToTouching( creatureB );
	    }
	}
	
	
	if( /*creatureB->type() != Creature::PLANT &&*/ // plants don't do anything to other creatures
	    !fixtureA->IsSensor()                    // and we can't see others' sight / sense others' sensors
	)
	{
	    if( fixtureB->IsSensor() )
	    {
		creatureB->addToNearBy( creatureA );
	    }
	    else
	    {
		creatureB->addToTouching( creatureA );
	    }
	}
    }
}

void ALContactListener::EndContact(b2Contact* contact)
{
    b2Fixture *fixtureA = contact->GetFixtureA();
    Creature* creatureA = (Creature *) fixtureA->GetBody()->GetUserData();
    
    b2Fixture *fixtureB = contact->GetFixtureB();
    Creature* creatureB = (Creature *) fixtureB->GetBody()->GetUserData();
    
    if( creatureA && creatureB )
    {
	if( !fixtureB->IsSensor() )
	{
	    if( fixtureA->IsSensor() )
	    {
		creatureA->removeFromNearBy( creatureB );
	    }
	    else
	    {
		creatureA->removeFromTouching( creatureB );
	    }
	}
	
	
	if( !fixtureA->IsSensor() )
	{
	    if( fixtureB->IsSensor() )
	    {
		creatureB->removeFromNearBy( creatureA );
	    }
	    else
	    {
		creatureB->removeFromTouching( creatureA );
	    }
	}
    }
}
